Index: /trunk/src/bp-core/bp-core-buddybar.php
===================================================================
--- /trunk/src/bp-core/bp-core-buddybar.php	(revision 10744)
+++ /trunk/src/bp-core/bp-core-buddybar.php	(revision 10745)
@@ -809,8 +815,56 @@
 	}
 
-	unset( $bp->bp_options_nav[$parent_id][$slug] );
-
-	if ( isset( $bp->bp_options_nav[$parent_id] ) && !count( $bp->bp_options_nav[$parent_id] ) )
-		unset($bp->bp_options_nav[$parent_id]);
+	return true;
+}
+
+/**
+ * Deletes an item from the secondary navigation of the specified component.
+ *
+ * @since 1.0.0
+ * @since 2.6.0 Introduced the `$component` parameter.
+ *
+ * @param string $parent_slug The slug of the primary navigation item.
+ * @param string $slug        The slug of the secondary item to be removed.
+ * @param string $component   The component the navigation is attached to. Defaults to 'members'.
+ * @return bool Returns false on failure, True on success.
+ */
+function bp_core_remove_subnav_item( $parent_slug, $slug, $component = null ) {
+	$bp = buddypress();
+
+	// Backward compatibility for removing group nav items using the group slug as `$parent_slug`.
+	if ( ! $component && bp_is_active( 'groups' ) && isset( $bp->groups->nav ) ) {
+		if ( $bp->groups->nav->get_primary( array( 'slug' => $parent_slug ) ) ) {
+			return bp_core_remove_subnav_item( $slug, $parent_slug, 'groups' );
+		}
+	}
+
+	if ( ! $component ) {
+		$component = 'members';
+	}
+
+	if ( ! isset( $bp->{$component}->nav ) ) {
+		return false;
+	}
+
+	$screen_functions = $bp->{$component}->nav->delete_nav( $slug, $parent_slug );
+
+	// Reset backcompat nav items so that subsequent references will be correct.
+	if ( buddypress()->do_nav_backcompat ) {
+		$bp->bp_nav->reset();
+		$bp->bp_options_nav->reset();
+	}
+
+	if ( ! is_array( $screen_functions ) ) {
+		return false;
+	}
+
+	$screen_function = reset( $screen_functions );
+
+	// Remove our screen hook if screen function is callable.
+	if ( is_callable( $screen_function ) ) {
+		remove_action( 'bp_screens', $screen_function, 3 );
+	}
+
+	return true;
 }
 
@@ -819,11 +873,25 @@
  *
  * @since 1.0.0
+ * @since 2.6.0 Introduced the `$component` parameter.
  *
  * @param string $parent_slug The slug of the parent navigation item.
- */
-function bp_core_reset_subnav_items( $parent_slug ) {
+ * @param string $component   The component the navigation is attached to. Defaults to 'members'.
+ */
+function bp_core_reset_subnav_items( $parent_slug, $component = 'members' ) {
 	$bp = buddypress();
 
-	unset( $bp->bp_options_nav[$parent_slug] );
+	if ( ! isset( $bp->{$component}->nav ) ) {
+		return;
+	}
+
+	$subnav_items = $bp->{$component}->nav->get_secondary( array( 'parent_slug' => $parent_slug ), false );
+
+	if ( ! $subnav_items ) {
+		return;
+	}
+
+	foreach( $subnav_items as $subnav_item ) {
+		$bp->{$component}->nav->delete_nav( $subnav_item->slug, $parent_slug );
+	}
 }
 
Index: /trunk/src/bp-core/bp-core-classes.php
===================================================================
--- /trunk/src/bp-core/bp-core-classes.php	(revision 10744)
+++ /trunk/src/bp-core/bp-core-classes.php	(revision 10745)
@@ -31,2 +31,9 @@
 require dirname( __FILE__ ) . '/classes/class-bp-email-delivery.php';
 require dirname( __FILE__ ) . '/classes/class-bp-phpmailer.php';
+require dirname( __FILE__ ) . '/classes/class-bp-core-nav.php';
+require dirname( __FILE__ ) . '/classes/class-bp-core-nav-item.php';
+
+if ( buddypress()->do_nav_backcompat ) {
+	require dirname( __FILE__ ) . '/classes/class-bp-core-bp-nav-backcompat.php';
+	require dirname( __FILE__ ) . '/classes/class-bp-core-bp-options-nav-backcompat.php';
+}
Index: /trunk/src/bp-core/bp-core-functions.php
===================================================================
--- /trunk/src/bp-core/bp-core-functions.php	(revision 10744)
+++ /trunk/src/bp-core/bp-core-functions.php	(revision 10745)
@@ -2444,9 +2444,6 @@
 	}
 
-	// Pull up a list of items registered in BP's top-level nav array.
-	$bp_menu_items = buddypress()->bp_nav;
-
-	// Alphabetize.
-	$bp_menu_items = bp_alpha_sort_by_key( $bp_menu_items, 'name' );
+	// Pull up a list of items registered in BP's primary nav for the member.
+	$bp_menu_items = buddypress()->members->nav->get_primary();
 
 	// Some BP nav menu items will not be represented in bp_nav, because
@@ -2576,5 +2573,5 @@
  *
  * @param string $slug The slug of the nav item: login, register, or one of the
- *                     slugs from buddypress()->bp_nav.
+ *                     slugs from the members navigation.
  * @return string $nav_item_url The URL generated for the current user.
  */
Index: /trunk/src/bp-core/bp-core-template.php
===================================================================
--- /trunk/src/bp-core/bp-core-template.php	(revision 10744)
+++ /trunk/src/bp-core/bp-core-template.php	(revision 10745)
@@ -14,5 +14,5 @@
  * Output the "options nav", the secondary-level single item navigation menu.
  *
- * Uses the $bp->bp_options_nav global to render out the sub navigation for the
+ * Uses the component's nav global to render out the sub navigation for the
  * current component. Each component adds to its sub navigation array within
  * its own setup_nav() function.
@@ -41,13 +41,23 @@
 	$selected_item   = bp_current_action();
 
+	// Default to the Members nav.
 	if ( ! bp_is_single_item() ) {
-		if ( !isset( $bp->bp_options_nav[$component_index] ) || count( $bp->bp_options_nav[$component_index] ) < 1 ) {
+		// Set the parent slug, if not provided.
+		if ( empty( $parent_slug ) ) {
+			$parent_slug = $component_index;
+		}
+
+		$secondary_nav_items = $bp->members->nav->get_secondary( array( 'parent_slug' => $parent_slug ) );
+
+		if ( ! $secondary_nav_items ) {
 			return false;
-		} else {
-			$the_index = $component_index;
-		}
+		}
+
+	// For a single item, try to use the component's nav.
 	} else {
 		$current_item = bp_current_item();
-
+		$single_item_component = bp_current_component();
+
+		// Adjust the selected nav item for the current single item if needed.
 		if ( ! empty( $parent_slug ) ) {
 			$current_item  = $parent_slug;
@@ -55,19 +65,24 @@
 		}
 
-		if ( !isset( $bp->bp_options_nav[$current_item] ) || count( $bp->bp_options_nav[$current_item] ) < 1 ) {
+		// If the nav is not defined by the parent component, look in the Members nav.
+		if ( ! isset( $bp->{$single_item_component}->nav ) ) {
+			$secondary_nav_items = $bp->members->nav->get_secondary( array( 'parent_slug' => $current_item ) );
+		} else {
+			$secondary_nav_items = $bp->{$single_item_component}->nav->get_secondary( array( 'parent_slug' => $current_item ) );
+		}
+
+		if ( ! $secondary_nav_items ) {
 			return false;
-		} else {
-			$the_index = $current_item;
 		}
 	}
 
 	// Loop through each navigation item.
-	foreach ( (array) $bp->bp_options_nav[$the_index] as $subnav_item ) {
-		if ( empty( $subnav_item['user_has_access'] ) ) {
+	foreach ( $secondary_nav_items as $subnav_item ) {
+		if ( empty( $subnav_item->user_has_access ) ) {
 			continue;
 		}
 
 		// If the current action or an action variable matches the nav item id, then add a highlight CSS class.
-		if ( $subnav_item['slug'] == $selected_item ) {
+		if ( $subnav_item->slug === $selected_item ) {
 			$selected = ' class="current selected"';
 		} else {
@@ -89,5 +104,5 @@
 		 * @param string $selected_item Current action.
 		 */
-		echo apply_filters( 'bp_get_options_nav_' . $subnav_item['css_id'], '<li id="' . esc_attr( $subnav_item['css_id'] . '-' . $list_type . '-li' ) . '" ' . $selected . '><a id="' . esc_attr( $subnav_item['css_id'] ) . '" href="' . esc_url( $subnav_item['link'] ) . '">' . $subnav_item['name'] . '</a></li>', $subnav_item, $selected_item );
+		echo apply_filters( 'bp_get_options_nav_' . $subnav_item->css_id, '<li id="' . esc_attr( $subnav_item->css_id . '-' . $list_type . '-li' ) . '" ' . $selected . '><a id="' . esc_attr( $subnav_item->css_id ) . '" href="' . esc_url( $subnav_item->link ) . '">' . $subnav_item->name . '</a></li>', $subnav_item, $selected_item );
 	}
 }
@@ -3011,7 +3026,12 @@
 		$component_subnav_name = '';
 
+		if ( ! empty( $bp->members->nav ) ) {
+			$primary_nav_item = $bp->members->nav->get_primary( array( 'slug' => $component_id ), false );
+			$primary_nav_item = reset( $primary_nav_item );
+		}
+
 		// Use the component nav name.
-		if ( ! empty( $bp->bp_nav[$component_id] ) ) {
-			$component_name = _bp_strip_spans_from_title( $bp->bp_nav[ $component_id ]['name'] );
+		if ( ! empty( $primary_nav_item->name ) ) {
+			$component_name = _bp_strip_spans_from_title( $primary_nav_item->name );
 
 		// Fall back on the component ID.
@@ -3020,11 +3040,18 @@
 		}
 
+		if ( ! empty( $bp->members->nav ) ) {
+			$secondary_nav_item = $bp->members->nav->get_secondary( array(
+				'parent_slug' => $component_id,
+				'slug'        => bp_current_action()
+			), false );
+
+			if ( $secondary_nav_item ) {
+				$secondary_nav_item = reset( $secondary_nav_item );
+			}
+		}
+
 		// Append action name if we're on a member component sub-page.
-		if ( ! empty( $bp->bp_options_nav[ $component_id ] ) && ! empty( $bp->canonical_stack['action'] ) ) {
-			$component_subnav_name = wp_filter_object_list( $bp->bp_options_nav[ $component_id ], array( 'slug' => bp_current_action() ), 'and', 'name' );
-
-			if ( ! empty( $component_subnav_name ) ) {
-				$component_subnav_name = array_shift( $component_subnav_name );
-			}
+		if ( ! empty( $secondary_nav_item->name ) && ! empty( $bp->canonical_stack['action'] ) ) {
+			$component_subnav_name = $secondary_nav_item->name;
 		}
 
@@ -3046,12 +3073,26 @@
 		}
 
-	// A single group.
-	} elseif ( bp_is_active( 'groups' ) && ! empty( $bp->groups->current_group ) && ! empty( $bp->bp_options_nav[ $bp->groups->current_group->slug ] ) ) {
-		$subnav      = isset( $bp->bp_options_nav[ $bp->groups->current_group->slug ][ bp_current_action() ]['name'] ) ? $bp->bp_options_nav[ $bp->groups->current_group->slug ][ bp_current_action() ]['name'] : '';
-		$bp_title_parts = array( $bp->bp_options_title, $subnav );
-
-	// A single item from a component other than groups.
+	// A single item from a component other than Members.
 	} elseif ( bp_is_single_item() ) {
-		$bp_title_parts = array( $bp->bp_options_title, $bp->bp_options_nav[ bp_current_item() ][ bp_current_action() ]['name'] );
+		$component_id = bp_current_component();
+
+		if ( ! empty( $bp->{$component_id}->nav ) ) {
+			$secondary_nav_item = $bp->{$component_id}->nav->get_secondary( array(
+				'parent_slug' => bp_current_item(),
+				'slug'        => bp_current_action()
+			), false );
+
+			if ( $secondary_nav_item ) {
+				$secondary_nav_item = reset( $secondary_nav_item );
+			}
+		}
+
+		$single_item_subnav = '';
+
+		if ( ! empty( $secondary_nav_item->name ) ) {
+			$single_item_subnav = $secondary_nav_item->name;
+		}
+
+		$bp_title_parts = array( $bp->bp_options_title, $single_item_subnav );
 
 	// An index or directory.
@@ -3429,77 +3470,56 @@
  *
  * @since 1.7.0
- *
+ * @since 2.6.0 Introduced the `$component` parameter.
+ *
+ * @param string $component Optional. Component whose nav items are being fetched.
  * @return array A multidimensional array of all navigation items.
  */
-function bp_get_nav_menu_items() {
-	$menus = $selected_menus = array();
-
-	// Get the second level menus.
-	foreach ( (array) buddypress()->bp_options_nav as $parent_menu => $sub_menus ) {
-
-		// The root menu's ID is "xprofile", but the Profile submenus are using "profile". See BP_Core::setup_nav().
-		if ( 'profile' === $parent_menu ) {
-			$parent_menu = 'xprofile';
-		}
-
-		// Sort the items in this menu's navigation by their position property.
-		$second_level_menus = (array) $sub_menus;
-		usort( $second_level_menus, '_bp_nav_menu_sort' );
-
-		// Iterate through the second level menus.
-		foreach( $second_level_menus as $sub_nav ) {
-
-			// Skip items we don't have access to.
-			if ( empty( $sub_nav['user_has_access'] ) ) {
-				continue;
-			}
-
-			// Add this menu.
-			$menu         = new stdClass;
-			$menu->class  = array( 'menu-child' );
-			$menu->css_id = $sub_nav['css_id'];
-			$menu->link   = $sub_nav['link'];
-			$menu->name   = $sub_nav['name'];
-			$menu->parent = $parent_menu;  // Associate this sub nav with a top-level menu.
-
-			// If we're viewing this item's screen, record that we need to mark its parent menu to be selected.
-			if ( $sub_nav['slug'] == bp_current_action() ) {
-				$menu->class[]    = 'current-menu-item';
-				$selected_menus[] = $parent_menu;
-			}
-
-			$menus[] = $menu;
-		}
-	}
-
-	// Get the top-level menu parts (Friends, Groups, etc) and sort by their position property.
-	$top_level_menus = (array) buddypress()->bp_nav;
-	usort( $top_level_menus, '_bp_nav_menu_sort' );
-
-	// Iterate through the top-level menus.
-	foreach ( $top_level_menus as $nav ) {
-
-		// Skip items marked as user-specific if you're not on your own profile.
-		if ( empty( $nav['show_for_displayed_user'] ) && ! bp_core_can_edit_settings()  ) {
-			continue;
-		}
-
+function bp_get_nav_menu_items( $component = 'members' ) {
+	$bp    = buddypress();
+	$menus = array();
+
+	if ( ! isset( $bp->{$component}->nav ) ) {
+		return $menus;
+	}
+
+	// Get the item nav and build the menus.
+	foreach ( $bp->{$component}->nav->get_item_nav() as $nav_menu ) {
 		// Get the correct menu link. See https://buddypress.trac.wordpress.org/ticket/4624.
-		$link = bp_loggedin_user_domain() ? str_replace( bp_loggedin_user_domain(), bp_displayed_user_domain(), $nav['link'] ) : trailingslashit( bp_displayed_user_domain() . $nav['link'] );
+		$link = bp_loggedin_user_domain() ? str_replace( bp_loggedin_user_domain(), bp_displayed_user_domain(), $nav_menu->link ) : trailingslashit( bp_displayed_user_domain() . $nav_menu->link );
 
 		// Add this menu.
 		$menu         = new stdClass;
 		$menu->class  = array( 'menu-parent' );
-		$menu->css_id = $nav['css_id'];
-		$menu->link   = $link;
-		$menu->name   = $nav['name'];
+		$menu->css_id = $nav_menu->css_id;
+		$menu->link   = $nav_menu->link;
+		$menu->name   = $nav_menu->name;
 		$menu->parent = 0;
 
-		// Check if we need to mark this menu as selected.
-		if ( in_array( $nav['css_id'], $selected_menus ) ) {
-			$menu->class[] = 'current-menu-parent';
+		if ( ! empty( $nav_menu->children ) ) {
+			$submenus = array();
+
+			foreach( $nav_menu->children as $sub_menu ) {
+				$submenu = new stdClass;
+				$submenu->class  = array( 'menu-child' );
+				$submenu->css_id = $sub_menu->css_id;
+				$submenu->link   = $sub_menu->link;
+				$submenu->name   = $sub_menu->name;
+				$submenu->parent = $nav_menu->slug;
+
+				// If we're viewing this item's screen, record that we need to mark its parent menu to be selected.
+				if ( $sub_menu->slug == bp_current_action() ) {
+					$menu->class[]    = 'current-menu-parent';
+					$submenu->class[] = 'current-menu-item';
+				}
+
+				$submenus[] = $submenu;
+			}
 		}
 
 		$menus[] = $menu;
+
+		if ( ! empty( $submenus ) ) {
+			$menus = array_merge( $menus, $submenus );
+		}
 	}
 
Index: /trunk/src/bp-core/classes/class-bp-component.php
===================================================================
--- /trunk/src/bp-core/classes/class-bp-component.php	(revision 10744)
+++ /trunk/src/bp-core/classes/class-bp-component.php	(revision 10745)
@@ -490,10 +490,10 @@
 		// No sub nav items without a main nav item.
 		if ( !empty( $main_nav ) ) {
-			bp_core_new_nav_item( $main_nav );
+			bp_core_new_nav_item( $main_nav, 'members' );
 
 			// Sub nav items are not required.
 			if ( !empty( $sub_nav ) ) {
 				foreach( (array) $sub_nav as $nav ) {
-					bp_core_new_subnav_item( $nav );
+					bp_core_new_subnav_item( $nav, 'members' );
 				}
 			}
Index: /trunk/src/bp-core/classes/class-bp-core-bp-nav-backcompat.php
===================================================================
--- /trunk/src/bp-core/classes/class-bp-core-bp-nav-backcompat.php	(revision 10745)
+++ /trunk/src/bp-core/classes/class-bp-core-bp-nav-backcompat.php	(revision 10745)
@@ -0,0 +1,270 @@
+<?php
+/**
+ * Backward compatibility for the $bp->bp_nav global.
+ *
+ * @since 2.6.0
+ */
+
+// Exit if accessed directly.
+defined( 'ABSPATH' ) || exit;
+
+/**
+ * bp_nav backward compatibility class.
+ *
+ * This class is used to provide backward compatibility for extensions that access and modify
+ * the $bp->bp_nav global.
+ *
+ * @since 2.6.0
+ */
+class BP_Core_BP_Nav_BackCompat implements ArrayAccess {
+	/**
+	 * Nav items.
+	 *
+	 * @since 2.6.0
+	 * @access public
+	 * @var array
+	 */
+	public $backcompat_nav = array();
+
+	/**
+	 * Component to which nav items belong.
+	 *
+	 * @since 2.6.0
+	 * @access public
+	 * @var array
+	 */
+	public $component;
+
+	/**
+	 * Constructor.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param array $backcompat_nav Optional. Array of nav items.
+	 */
+	public function __construct( $backcompat_nav = array() ) {
+		foreach ( $backcompat_nav as $key => $value ) {
+			if ( is_array( $value ) ) {
+				$this->backcompat_nav[ $key ] = new self( $value );
+			} else {
+				$this->backcompat_nav[ $key ] = $value;
+			}
+		}
+	}
+
+	/**
+	 * Assign a value to the nav array at the specified offset.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param mixed $offset Array offset.
+	 * @param array $value  Nav item.
+	 */
+	public function offsetSet( $offset, $value ) {
+		_doing_it_wrong(
+			'bp_nav',
+			__( 'The bp_nav and bp_options_nav globals should not be used directly and are deprecated. Please use the BuddyPress nav functions instead.', 'buddypress' ),
+			'2.6.0'
+		);
+
+		$bp = buddypress();
+
+		if ( is_array( $value ) ) {
+			$value = new self( $value );
+		}
+
+		if ( $offset !== null ) {
+			// Temporarily set the backcompat_nav.
+			$this->backcompat_nav[ $offset ] = $value;
+
+			$args = $this->to_array();
+			if ( isset( $args['parent_slug'] ) ) {
+				$this->get_component_nav( $args['parent_slug'] )->edit_nav( $args, $args['slug'], $args['parent_slug'] );
+			} elseif ( isset( $args['slug'] ) ) {
+				$bp->members->nav->edit_nav( $args, $args['slug'] );
+			}
+		}
+	}
+
+	/**
+	 * Get a value of the nav array at the specified offset.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param mixed $offset Array offset.
+	 * @return BP_Core_BP_Nav_BackCompat
+	 */
+	public function offsetGet( $offset ) {
+		_doing_it_wrong(
+			'bp_nav',
+			__( 'The bp_nav and bp_options_nav globals should not be used directly and are deprecated. Please use the BuddyPress nav functions instead.', 'buddypress' ),
+			'2.6.0'
+		);
+
+//		if ( ! isset( $this->backcompat_nav[ $offset ] ) ) {
+			$nav = $this->get_nav( $offset );
+			if ( $nav && isset( $nav[ $offset ] ) ) {
+				$this->backcompat_nav[ $offset ] = new self( $nav[ $offset ] );
+			}
+//		}
+
+		return $this->backcompat_nav[ $offset ];
+	}
+
+	/**
+	 * Check whether nav array has a value at the specified offset.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param mixed $offset Array offset.
+	 * @return bool
+	 */
+	public function offsetExists( $offset ) {
+		_doing_it_wrong(
+			'bp_nav',
+			__( 'The bp_nav and bp_options_nav globals should not be used directly and are deprecated. Please use the BuddyPress nav functions instead.', 'buddypress' ),
+			'2.6.0'
+		);
+
+		if ( isset( $this->backcompat_nav[ $offset ] ) ) {
+			return true;
+		}
+
+		$nav = $this->get_nav( $offset );
+		if ( $nav && isset( $nav[ $offset ] ) ) {
+			return true;
+		}
+
+		return false;
+	}
+
+	/**
+	 * Unset a nav array value at the specified offset.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param mixed $offset Array offset.
+	 */
+	public function offsetUnset( $offset ) {
+		_doing_it_wrong(
+			'bp_nav',
+			__( 'The bp_nav and bp_options_nav globals should not be used directly and are deprecated. Please use the BuddyPress nav functions instead.', 'buddypress' ),
+			'2.6.0'
+		);
+
+		// For top-level nav items, the backcompat nav hasn't yet been initialized.
+		if ( ! isset( $this->backcompat_nav[ $offset ] ) ) {
+			buddypress()->members->nav->delete_nav( $offset );
+			unset( $this->backcompat_nav[ $offset ] );
+		}
+	}
+
+	/**
+	 * Set the component to which the nav belongs.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param string $component
+	 */
+	public function set_component( $component ) {
+		$this->component = $component;
+	}
+
+	/**
+	 * Get the component to which the a nav item belongs.
+	 *
+	 * We use the following heuristic to guess, based on an offset, which component the item belongs to:
+	 *   - If this is a group, and the offset is the same as the current group's slug, it's a group nav item.
+	 *   - Otherwise, it's a member nav item.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param mixed $offset Array offset.
+	 * @return string
+	 */
+	public function get_component( $offset = '' ) {
+		if ( ! isset( $this->component ) ) {
+			if ( bp_is_active( 'groups' ) && $offset === bp_get_current_group_slug() ) {
+				$this->component = 'groups';
+			} else {
+				$this->component = 'members';
+			}
+		}
+
+		return $this->component;
+	}
+
+	/**
+	 * Reset the cached nav items.
+	 *
+	 * Called when the nav API removes items from the nav array.
+	 *
+	 * @since 2.6.0
+	 */
+	public function reset() {
+		$this->backcompat_nav = array();
+	}
+
+	/**
+	 * Get the nav object corresponding to the specified offset.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param mixed $offset Array offset.
+	 * @return bool|array
+	 */
+	protected function get_nav( $offset ) {
+		$bp = buddypress();
+
+		$component_nav = $this->get_component_nav( $offset );
+		$primary_nav   = $component_nav->get_primary( array( 'slug' => $offset ), false );
+
+		$nav = array();
+
+		if ( empty( $primary_nav ) ) {
+			return $nav;
+		}
+
+		foreach ( $primary_nav as $item ) {
+			$nav[ $item->slug ] = (array) $item;
+		}
+
+		return $nav;
+	}
+
+	/**
+	 * Get the BP_Core_Nav object corresponding to the component, based on a nav item name.
+	 *
+	 * The way bp_nav was previously organized makes it impossible to know for sure which component's nav is
+	 * being referenced by a given nav item name. We guess in the following manner:
+	 *   - If we're looking at a group, and the nav item name (`$offset`) is the same as the slug of the current
+	 *     group, we assume that the proper component nav is 'groups'.
+	 *   - Otherwise, fall back on 'members'.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param string $offset Nav item name.
+	 * @return BP_Core_Nav
+	 */
+	protected function get_component_nav( $offset = '' ) {
+		$component = $this->get_component( $offset );
+
+		$bp = buddypress();
+		if ( ! isset( $bp->{$component}->nav ) ) {
+			return false;
+		}
+
+		return $bp->{$component}->nav;
+	}
+
+	/**
+	 * Get the nav data, formatted as a flat array.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @return array
+	 */
+	protected function to_array() {
+		return $this->backcompat_nav;
+	}
+}
Index: /trunk/src/bp-core/classes/class-bp-core-bp-options-nav-backcompat.php
===================================================================
--- /trunk/src/bp-core/classes/class-bp-core-bp-options-nav-backcompat.php	(revision 10745)
+++ /trunk/src/bp-core/classes/class-bp-core-bp-options-nav-backcompat.php	(revision 10745)
@@ -0,0 +1,134 @@
+<?php
+/**
+ * Backward compatibility for the $bp->bp_options_nav global.
+ *
+ * @since 2.6.0
+ */
+
+// Exit if accessed directly.
+defined( 'ABSPATH' ) || exit;
+
+/**
+ * bp_options_nav backward compatibility class.
+ *
+ * This class is used to provide backward compatibility for extensions that access and modify
+ * the $bp->bp_options_nav global.
+ *
+ * @since 2.6.0
+ */
+class BP_Core_BP_Options_Nav_BackCompat extends BP_Core_BP_Nav_BackCompat {
+	/**
+	 * Parent slug of the current nav item.
+	 *
+	 * @since 2.6.0
+	 * @access protected
+	 * @var string
+	 */
+	protected $parent_slug = '';
+
+	/**
+	 * Get a value of the nav array at the specified offset.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param mixed $offset Array offset.
+	 * @return BP_Core_BP_Nav_BackCompat
+	 */
+	public function offsetGet( $offset ) {
+		_doing_it_wrong(
+			'bp_nav',
+			__( 'These globals should not be used directly and are deprecated. Please use the BuddyPress nav functions instead.', 'buddypress' ),
+			'2.6.0'
+		);
+
+		if ( empty( $this->backcompat_nav[ $offset ] ) ) {
+			$nav = $this->get_nav( $offset );
+			if ( $nav ) {
+				$subnavs = $this->get_component_nav( $offset )->get_secondary( array( 'parent_slug' => $offset ) );
+				$subnav_keyed = array();
+				if ( $subnavs ) {
+					foreach ( $subnavs as $subnav ) {
+						$subnav_keyed[ $subnav->slug ] = (array) $subnav;
+					}
+				}
+
+				$subnav_object = new self( $subnav_keyed );
+				$subnav_object->set_component( $this->get_component() );
+				$subnav_object->set_parent_slug( $offset );
+
+				$this->backcompat_nav[ $offset ] = $subnav_object;
+			}
+		}
+
+		return $this->backcompat_nav[ $offset ];
+	}
+
+	/**
+	 * Unset a nav array value at the specified offset.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param mixed $offset Array offset.
+	 */
+	public function offsetUnset( $offset ) {
+		_doing_it_wrong(
+			'bp_nav',
+			__( 'These globals should not be used directly and are deprecated. Please use the BuddyPress nav functions instead.', 'buddypress' ),
+			'2.6.0'
+		);
+
+		$this->get_component_nav( $offset )->delete_nav( $offset, $this->get_parent_slug() );
+
+		// Clear the cached nav.
+		unset( $this->backcompat_nav[ $offset ] );
+	}
+
+	/**
+	 * Get the parent slug of the current nav item.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @return string
+	 */
+	public function get_parent_slug() {
+		return $this->parent_slug;
+	}
+
+	/**
+	 * Set the parent slug of the current nav item.
+	 *
+	 * @since 2.6.0
+	 */
+	public function set_parent_slug( $slug ) {
+		$this->parent_slug = $slug;
+	}
+
+	/**
+	 * Get the nav object corresponding to the specified offset.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param mixed $offset Array offset.
+	 * @return bool|array
+	 */
+	public function get_nav( $offset ) {
+		$nav = parent::get_nav( $offset );
+
+		if ( ! $nav ) {
+			$component_nav = $this->get_component_nav( $offset );
+			$secondary_nav = $component_nav->get_secondary( array( 'slug' => $offset ), false );
+
+			$nav = array();
+
+			if ( empty( $primary_nav ) ) {
+				return $nav;
+			}
+
+			foreach ( $primary_nav as $item ) {
+				$nav[ $item->slug ] = (array) $item;
+			}
+		}
+
+		return $nav;
+	}
+}
Index: /trunk/src/bp-core/classes/class-bp-core-nav-item.php
===================================================================
--- /trunk/src/bp-core/classes/class-bp-core-nav-item.php	(revision 10745)
+++ /trunk/src/bp-core/classes/class-bp-core-nav-item.php	(revision 10745)
@@ -0,0 +1,34 @@
+<?php
+
+// Exit if accessed directly.
+defined( 'ABSPATH' ) || exit;
+
+if ( class_exists( 'ArrayObject' ) ) :
+
+/**
+ * Navigation item.
+ *
+ * @since 2.6.0
+ */
+class BP_Core_Nav_Item extends ArrayObject {
+	public function __construct( $data ) {
+		parent::__construct( $data, ArrayObject::ARRAY_AS_PROPS );
+	}
+}
+
+else :
+
+/**
+ * Navigation item.
+ *
+ * @since 2.6.0
+ */
+class BP_Core_Nav_Item {
+	public function __construct( $data ) {
+		foreach ( $data as $key => $value ) {
+			$this->key = $value;
+		}
+	}
+}
+
+endif;
